#pragma once

#include <QtWidgets/QDialog>
#include <QFileDialog>
#include <QMetaType>
#include <QDialog>
#include <QDebug>
#include <QObject>
#include <QMessageBox> 
#include <QPushButton>
#include <QString>
#include <QThread>
#include <QVector>

#include "ui_DEM_GeneRas.h"
#include "ThreadObject.h"
#include "SrsMainPluginInterFace.h"

#include "gdal_priv.h"
//#include "gdal_alg_priv.h"

class VegePredict : public SrsMainInterface
{
	Q_OBJECT
		Q_INTERFACES(SrsMainInterface)
		Q_PLUGIN_METADATA(IID MainInterface_iid)

public:
	VegePredict();
	~VegePredict();

	virtual QString PannelName() override;
	virtual QString CategoryName() override;

	virtual QString EnglishName() override;
	virtual QString ChineseName() override;
	virtual QString Information() override;
	virtual QString IconPath() override;
	virtual QWidget* CenterWidget() override;

	//jsonļȡʷ洢·
	void ReadConfigHistoryPaths(QString strPath);
	//汾δ򿪵·jsonļ
	void WriteConfigPaths(QString strPath);

	void startWorkThread();

	void openResultData(QStringList string_list);

public slots:
	void chooseDomPath();
	void chooseDsmPath();
	void choosePreDir();
	void chooseMouleFile();

	void addMap();

	void readAndStart();
	void pbCancel();

signals:
	void start(QString Moudle, QString DOM, QString DSM, QString PRE);//, std::function<void(int)>func
	void killChildThread();
	void startTiffToShp(QString PRE, QString DSM);

private:
	Ui::DEM_GeneRasClass ui;

	QDialog* myWidget = nullptr;

	WorkThreadObject* mWorker = nullptr;

	QThread* mWorkThread = nullptr;

};
